/**
 * 
 */
package org.q2l.smallab;

import processing.core.*;

/**
 * @author Mike Edwards (mike@onearmedman.com)
 *
 */
public class FractionView {

	static public int BLOCK_HEIGHT = 50;
	
	PApplet parent;
	int width, height;
	Fraction fraction;
	boolean added, common = false;
	int lcd = 1;
	int multiplier = 1;
	float r = 0,b = 0,g = 0;
	
	/**
	 * @param parent
	 * @param iwidth
	 * @param iheight
	 * @param lcd 
	 * @param fraction 
	 */
	public FractionView(PApplet parent, int width, int height, Fraction fraction, int lcd) {
		this.parent = parent;
		this.width = width;
		this.height = height;
		this.fraction = fraction;
		this.lcd = lcd;
	}
	
	public void blockColor(float r, float g, float b)
	{
		this.r = r;
		this.g = g;
		this.b = b;
	}
	
	public int renderWidth()
	{
		return (int) (this.width/this.lcd * this.lcd);
	}
	
	public void draw()
	{
		if (this.fraction != null)
		{
			//this.beginDraw();
			
			//this.parent.background(0,0);
			
			this.parent.stroke(this.r,this.g,this.b,255);
			this.parent.fill(this.r,this.g,this.b,128);
			
			int div;
			
			if (this.common)
			{
				this.parent.stroke(255,255,255,255);
				div = this.parent.width/this.lcd;
				
				for(int f = 0; f <  this.lcd * this.fraction.numerator() / this.fraction.denominator(); f++)
				{
					this.parent.line(f*div + div/2,FractionView.BLOCK_HEIGHT * -4f,f*div + div/2,FractionView.BLOCK_HEIGHT);
					this.parent.triangle(f*div + div/2,FractionView.BLOCK_HEIGHT * -4f, 
							f*div + div/2 + 5,FractionView.BLOCK_HEIGHT * -4f + 10, 
							f*div + div/2 - 5,FractionView.BLOCK_HEIGHT * -4f + 10);
				}
			}

			this.parent.stroke(this.r,this.g,this.b,255);				
			
			if (this.added)
			{
				this.parent.stroke(255,255,255,255);

				div = this.parent.width/this.lcd;
				
				this.parent.fill(this.r,this.g,this.b,128);

				for(int f = 0; f <  this.lcd * this.fraction.numerator() / this.fraction.denominator(); f++)
				{
					this.parent.rect(f*div,FractionView.BLOCK_HEIGHT * -2f,div,FractionView.BLOCK_HEIGHT);
				}
				
				this.parent.fill(this.r,this.g,this.b,192);

				for(int f = 0; f < lcd; f++)
				{
					this.parent.rect(f*div,FractionView.BLOCK_HEIGHT,div,FractionView.BLOCK_HEIGHT);
				}
			}
			else
			{
				div = (int) (this.parent.width/(this.fraction.denominator() * this.multiplier));

				this.parent.fill(this.r,this.g,this.b,128);

				for(int f = 0; f <  this.fraction.numerator() * this.multiplier; f++)
				{
					this.parent.rect(f*div,FractionView.BLOCK_HEIGHT * -0.5f,div,FractionView.BLOCK_HEIGHT);
				}
				
				this.parent.fill(this.r,this.g,this.b,192);

				for(int f = 0; f < this.fraction.denominator() * this.multiplier; f++)
				{
					this.parent.rect(f*div,FractionView.BLOCK_HEIGHT,div,FractionView.BLOCK_HEIGHT);
				}
			}
			
			this.parent.fill(255);
			
			this.parent.strokeWeight(10);
			this.parent.line(0,FractionView.BLOCK_HEIGHT * 0.75f,width,FractionView.BLOCK_HEIGHT * 0.75f);

			this.parent.stroke(255);
			this.parent.strokeWeight(1);
			
			this.drawFraction(this.fraction.numerator(), 
					this.fraction.denominator(), 
					width/2f - 50.0f, 
					FractionView.BLOCK_HEIGHT * 2.5f);
			
			this.parent.text("x",width/2 - 25,FractionView.BLOCK_HEIGHT * 2.75f);

			this.drawFraction(this.multiplier, 
					this.multiplier, 
					width/2f + 0.0f, 
					FractionView.BLOCK_HEIGHT * 2.5f);
						
			this.parent.text("=",width/2 + 25,FractionView.BLOCK_HEIGHT * 2.75f);

			this.drawFraction(this.fraction.numerator() * this.multiplier, 
					this.fraction.denominator() * this.multiplier, 
					width/2f + 50.0f, 
					FractionView.BLOCK_HEIGHT * 2.5f);
			
			//this.endDraw();
		}
	}
	
	private void drawFraction(long n, long d, float x, float y) {
		this.parent.textFont(((PartsOfWholeDemo)this.parent).numberFont);
		this.parent.text("" + n,x,y);
		this.parent.strokeWeight(2);
		this.parent.line(x,y + 3,x + this.parent.textWidth("" + d),y + 3);
		this.parent.text("" + d,x,y + FractionView.BLOCK_HEIGHT * 0.5f);
	}

}
